unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, OleCtnrs, Menus, ExtCtrls, StdCtrls;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    NewObject1: TMenuItem;
    Exit1: TMenuItem;
    OleContainer1: TOleContainer;
    NewExcelWorksheet1: TMenuItem;
    N1: TMenuItem;
    Action1: TMenuItem;
    ShowProrerties1: TMenuItem;
    Pastespecial1: TMenuItem;
    Panel2: TPanel;
    ComboBox1: TComboBox;
    CreatePivotTable1: TMenuItem;
    procedure NewObject1Click(Sender: TObject);
    procedure ShowProrerties1Click(Sender: TObject);
    procedure Pastespecial1Click(Sender: TObject);
    procedure NewExcelWorksheet1Click(Sender: TObject);
    procedure ComboBox1Change(Sender: TObject);
    procedure CreatePivotTable1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  WB,PC,PT:Variant;

const
  // Excel 
  xlExternal = $00000002;
  xlCmdSql = $00000002;
  xlColumnField = $00000002;
  xlDataField = $00000004;
  xlPageField = $00000003;
  xlRowField = $00000001;

implementation

{$R *.dfm}

procedure TForm1.NewObject1Click(Sender: TObject);
begin
  OleContainer1.InsertObjectDialog;
  ComboBox1.Items:=OleContainer1.ObjectVerbs;
  ComboBox1.Enabled:=True;
end;

procedure TForm1.ShowProrerties1Click(Sender: TObject);
begin
 if OleContainer1.OleObjectInterface <> nil then
      OleContainer1.ObjectPropertiesDialog
 else ShowMessage ('OleContainer is empty');
end;

procedure TForm1.Pastespecial1Click(Sender: TObject);
begin
  OleContainer1.PasteSpecialDialog;
end;

procedure TForm1.NewExcelWorksheet1Click(Sender: TObject);
begin
  OleContainer1.CreateObject('Excel.Sheet', False);
  ComboBox1.Items:=OleContainer1.ObjectVerbs;
  ComboBox1.Enabled:=True;
end;

procedure TForm1.ComboBox1Change(Sender: TObject);
begin
  if OleContainer1.State <> osEmpty then
    OleContainer1.DoVerb(ComboBox1.ItemIndex);
end;

procedure TForm1.CreatePivotTable1Click(Sender: TObject);
begin
 OleContainer1.CreateObject('Excel.Sheet',False);
 WB := OleContainer1.OleObject;
 // .
 PC := WB.PivotCaches.Add(xlExternal);
 //     .
 PC.Connection  := 'OLEDB;Provider=Microsoft.Jet.OLEDB.4.0;Data Source=C:\Program Files\Microsoft Office\Office10\Samples\.mdb';
 PC.CommandType := xlCmdSql;
 PC.CommandText := 'SELECT , , '+
             ' ,  FROM   ';
 //C  .
 PC.CreatePivotTable(WB.Worksheets[1].Cells[1,1],'PivotTable1');
 PT := WB.Worksheets[1].PivotTables('PivotTable1');
 //     .
 PT.PivotFields('').Orientation := xlRowField;
 PT.PivotFields('').Position := 1;
 PT.PivotFields('').Orientation := xlRowField;
 PT.PivotFields('').Position := 2;
 PT.PivotFields('').Orientation   := xlColumnField;
 PT.PivotFields('').Orientation := xlDataField;
 WB.Worksheets[1].Columns[2].ColumnWidth := 15;
 WB.Worksheets[1].Columns[1].ColumnWidth := 20;
end;

end.
